SystemOrganization addCategory: #'TP BichOS'!

Object subclass: #Alimento
	instanceVariableNames: 'masa posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Alimento methodsFor: 'as yet unclassified' stamp: 'Anonymous 9/18/2015 13:20'!
extraerComida: limite 
	| masaExtraida |
	masaExtraida := (limite  min: (masa-1) ).
	masa := masa - (masaExtraida + 1).
	^ 0 max: masaExtraida.
 
			! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa
	^ masa! !

!Alimento methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 15:39'!
masa: anObject
	masa := anObject! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion
^ posicion
! !

!Alimento methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 17:21'!
posicion: unPunto
posicion:= unPunto! !

Alimento subclass: #GalletitaOreo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!GalletitaOreo methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:58'!
initialize
	masa := 10000! !

Alimento subclass: #MedioAlfajor
	instanceVariableNames: 'chipsDeChocolate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!MedioAlfajor methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 20:01'!
chipsDeChocolate: anObject
	chipsDeChocolate := anObject.
	masa := chipsDeChocolate * 20! !

!MedioAlfajor methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:03'!
initialize
	self chipsDeChocolate: 0! !

Alimento subclass: #MigaDePan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!MigaDePan methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:59'!
initialize
	masa := 2000! !

Alimento subclass: #ZapatillaDeLona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!ZapatillaDeLona methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 19:59'!
extraerComida: limite ! !

Object subclass: #Cansada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 16:00'!
cambiarEstado: unaHormiga
unaHormiga estado: normal.! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:25'!
descansar: unaHormiga
	self cambiarEstado: unaHormiga.
	unaHormiga distanciaRecorridaParaCansancio:  0! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:05'!
extraerComidaDe: unAlimento con: unaHormiga! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:38'!
irA: unPunto con: unaHormiga
! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:37'!
llevarAlimentoA: unHormiguero con: unaHormiga
! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:26'!
normal
^normal! !

!Cansada methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:44'!
normal: unEstado
normal:= unEstado
! !

Object subclass: #Exaltada
	instanceVariableNames: 'normal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:59'!
cambiarEstado: unaHormiga
unaHormiga estado: normal.! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:32'!
descansar: unaHormiga! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:43'!
extraerComidaDe: unAlimento con: unaHormiga
	unaHormiga extraerTodaLaComidaDe: unAlimento limite: (unaHormiga limiteDeCargaDisponible + 10).! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:45'!
irA: unPunto con: unaHormiga
	unaHormiga irAUnDeterminado: unPunto distCansancio: 5.
! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:57'!
llevarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga llevarAlimentoTotalA: unHormiguero! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:27'!
normal
^normal
! !

!Exaltada methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:26'!
normal: unEstado
normal:= unEstado
! !

Object subclass: #Hormiga
	instanceVariableNames: 'pesoLlevado distanciaRecorrida posicion puntosRecorridos estado distanciaRecorridaNpuntos posicionDos distanciaRecorridaParaCansancio distanciaRecorridaEnUnaCantidadDePuntos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/19/2015 11:26'!
descansar
	estado descansar: self.
	! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:40'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:41'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'Federico 10/7/2015 22:13'!
distanciaRecorridaEnUnaCantidadDePuntos
	  ^distanciaRecorridaEnUnaCantidadDePuntos.! !

!Hormiga methodsFor: 'accessing' stamp: 'Federico 10/7/2015 22:13'!
distanciaRecorridaEnUnaCantidadDePuntos: unaCantidad
distanciaRecorridaEnUnaCantidadDePuntos:= unaCantidad.
! !

!Hormiga methodsFor: 'accessing' stamp: 'Federico 10/7/2015 23:00'!
distanciaRecorridaEnUnaUltimaCantidadDePuntos: unaCantidad 

self distanciaRecorridaEnUnaCantidadDePuntos:0.
self posicionDos: (self ultimaCantidadDePuntos:unaCantidad )first.

((self ultimaCantidadDePuntos: unaCantidad )allButFirst) do: [ :punto | self irADeUnaCantidadDePuntos: punto ].
^self distanciaRecorridaEnUnaCantidadDePuntos.! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 20:21'!
distanciaRecorridaParaCansancio
	^distanciaRecorridaParaCansancio! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 20:21'!
distanciaRecorridaParaCansancio: unaCantidad
distanciaRecorridaParaCansancio:= unaCantidad.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 15:59'!
distanciaRecorridaPromedio
	^ distanciaRecorrida / (puntosRecorridos size)! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:18'!
distanciaRecorridaPromedioEnUnaUltimaCantidadDePuntos: unaCantidad
	^ (self distanciaRecorridaEnUnaUltimaCantidadDePuntos:unaCantidad ) / unaCantidad! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:14'!
estaAlLimite
	^ pesoLlevado >= 9! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 16:38'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:27'!
extraerComidaDe: unAlimento
	estado extraerComidaDe: unAlimento con: self ! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:43'!
extraerTodaLaComidaDe: unAlimento limite: unLimite
      self irA:  unAlimento posicion.
	self pesoLlevado: pesoLlevado + (unAlimento extraerComida: unLimite)! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:16'!
initialize
	distanciaRecorrida := 0.
	self distanciaRecorridaParaCansancio: 0.
	self pesoLlevado: 0.
	self puntosRecorridos: OrderedCollection new.
	estado := Normal new.
	! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:29'!
irA: unPunto
	estado irA:unPunto con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 23:00'!
irADeUnaCantidadDePuntos: unPunto
	self distanciaRecorridaNpuntos: ((self distanciaRecorridaEnUnaCantidadDePuntos) + ((self posicionDos )distanciaA: unPunto)).
	self posicionDos: unPunto.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:45'!
irAUnDeterminado: unPunto distCansancio: unaDistancia
	self distanciaRecorrida: ((self distanciaRecorrida) +((self posicion )distanciaA: unPunto)).
	self distanciaRecorridaParaCansancio: self distanciaRecorridaParaCansancio   + ((self posicion )distanciaA: unPunto).
	self posicion: unPunto.
	(self puntosRecorridos) add: unPunto.
	(self distanciaRecorridaParaCansancio  > unaDistancia) ifTrue: [self estado cambiarEstado:self ]! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 21:14'!
limiteDeCargaDisponible
^ 10 - pesoLlevado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 15:35'!
llevarAlimentoA: unHormiguero
	estado llevarAlimentoA: unHormiguero con: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:57'!
llevarAlimentoTotalA: unHormiguero
	
	unHormiguero aumentarDeposito: self pesoLlevado.
	self pesoLlevado: 0.
	self irA: (unHormiguero posicion). ! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 21:14'!
pesoLlevado
	^ pesoLlevado! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/19/2015 21:15'!
pesoLlevado: anObject
	pesoLlevado := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion
	^ posicion! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:39'!
posicion: anObject
	posicion := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 14:05'!
posicionDos
	^ posicionDos! !

!Hormiga methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 14:05'!
posicionDos: anObject
	posicionDos := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos
	^ puntosRecorridos! !

!Hormiga methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:44'!
puntosRecorridos: anObject
	puntosRecorridos := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'Federico 10/7/2015 22:15'!
ultimaCantidadDePuntos: unaCantidad 
^( self puntosRecorridos) copyFrom:  (self puntosRecorridos size)- unaCantidad to: ( self puntosRecorridos size)! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigas deposito posicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Hormiguero methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/16/2015 16:17'!
agregarHormiga: unaHormiga

(self hormigas) add: unaHormiga.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:17'!
alimentoRecolectado
	^ hormigas sum: [: hormiga | hormiga pesoLlevado]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 12:37'!
alimentoTotal
	^ deposito + self alimentoRecolectado! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:51'!
aumentarDeposito: unaCantidad
	self deposito: deposito + unaCantidad ! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 16:13'!
cantidadDeHormigas
	^ hormigas size! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas
	^ hormigas! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:19'!
hormigas: anObject
	hormigas := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 21:38'!
hormigasAlLimite
	^ (hormigas select: [: hormiga | hormiga estaAlLimite]) size! !

!Hormiguero methodsFor: 'accessing' stamp: 'RodrigoAlvarez 9/17/2015 15:52'!
initialize
self hormigas: Bag new.
deposito:=0.
! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion
	^ posicion! !

!Hormiguero methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 13:47'!
posicion: anObject
	posicion := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/9/2015 13:50'!
reclamarAlimento
	hormigas do: [: hormiga | hormiga llevarAlimentoA: self].! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/17/2015 16:12'!
recorridoTotalHormigas
^self hormigas sum: [ :hormiga | hormiga distanciaRecorrida  ]! !

Object subclass: #Normal
	instanceVariableNames: 'exaltada cansada'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:25'!
cambiarEstado: unaHormiga
	unaHormiga estado: cansada.
	
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'JulianBerbelAlt 9/19/2015 20:24'!
descansar: unaHormiga
	unaHormiga estado: exaltada.
	unaHormiga distanciaRecorridaParaCansancio:0.
	
! !

!Normal methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:43'!
extraerComidaDe: unAlimento con: unaHormiga
	unaHormiga extraerTodaLaComidaDe: unAlimento limite: unaHormiga limiteDeCargaDisponible.
	! !

!Normal methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/19/2015 10:23'!
initialize
cansada := Cansada new.
cansada normal: self.
exaltada := Exaltada new.
exaltada normal: self.! !

!Normal methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:45'!
irA:unPunto con: unaHormiga
	unaHormiga irAUnDeterminado: unPunto distCansancio: 10.! !

!Normal methodsFor: 'as yet unclassified' stamp: 'Federico 10/7/2015 22:57'!
llevarAlimentoA: unHormiguero con: unaHormiga
	unaHormiga llevarAlimentoTotalA: unHormiguero! !

Object subclass: #Punto
	instanceVariableNames: 'latitud longitud'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP BichOS'!

!Punto methodsFor: 'as yet unclassified' stamp: 'RodrigoAlvarez 9/16/2015 13:51'!
distanciaA: otroPunto
	^(((latitud-otroPunto latitud)**2)+ ((longitud - otroPunto longitud) **2 ))sqrt.
! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud
	^ latitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
latitud: anObject
	latitud := anObject! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud
	^ longitud! !

!Punto methodsFor: 'accessing' stamp: 'JulianBerbelAlt 9/9/2015 12:55'!
longitud: anObject
	longitud := anObject! !
